---

- name: Add 'ppa:yubico' repository
  apt_repository:
    repo: 'ppa:yubico/stable'

- name: Install 'libpam_yubico'
  apt:
    pkg: libpam-yubico
    state: present

- name: Create '.yubico' directory in user home directory
  file:
    path: '{{ "~" + item.name | expanduser }}/.yubico/'
    state: directory
    owner: '{{ item.name }}'
    group: '{{ item.name }}'
    mode: 0700
  with_items: '{{ yubikey_users }}'

- name: Add yubikey ID's to '~/.yubico/authorized_yubikeys'
  lineinfile:
    path: '{{ "~" + item.name | expanduser }}/.yubico/authorized_yubikeys'
    line: '{{ item.name }}:{{item.authorized_yubikeys }}'
    state: present
    create: yes
    owner: '{{ item.name }}'
    group: '{{ item.name }}'
    mode: 0600
  with_items: '{{ yubikey_users }}'

- name: Ensure '/etc/pam.d/sshd' does not include common-auth
  lineinfile:
    state: present
    dest: /etc/pam.d/sshd
    regexp: '^@include common-auth$'
    line: '#@include common-auth'
    backrefs: yes
    backup: yes

- name: Ensure '/etc/pam.d/sshd' has required yubico authenticator configuration
  pamd:
    name: sshd
    new_type: auth
    new_control: sufficient
    new_module_path: pam_yubico.so
    module_arguments: "id={{ yubico_client_id }}"
    state: before
    type: account
    control: required
    module_path: pam_nologin.so
